%define name courier-imap
%define version 1.3.11
%define release 2rph

Name:		%{name}
Summary:	Courier-IMAP IMAP/POP3 server
Version:	%{version}
Release:	%{release}
Copyright:	GPL
Group:		System/Servers
URL:		http://www.courier-mta.org/
Source:		%{name}-%{version}.tar.bz2
BuildRoot:	%{_tmppath}/%{name}-%{version}
Requires:	/sbin/chkconfig fileutils textutils sh-utils sed
BuildPreReq:	textutils openssl-devel fileutils sed perl gdbm-devel
Packager:	Vincent Danen <vdanen@mandrakesoft.com>

%define _localstatedir /var/run

%define	authdaemondir	%{_localstatedir}/authdaemon.courier-imap

%description
Courier-IMAP is an IMAP server for Maildir mailboxes.  This package contains
the standalone version of the IMAP server that's included in the Courier
mail server package.  This package is a standalone version for use with
other mail servers.  Do not install this package if you intend to install the
full Courier mail server.  Install the Courier package instead.

%package ldap
Summary:	Courier-IMAP LDAP authentication driver.
Group:		System/Servers
Requires:	%{name} = %{version}

%description ldap
This package contains the necessary files to allow Courier-IMAP to
authenticate from an LDAP directory.  Install this package if you need
the ability to use an LDAP directory for authentication.

%package mysql
Summary:	Courier-IMAP MySQL authentication driver.
Group:		System/Servers
Requires:	%{name} = %{version}

%description mysql
This package contains the necessary files to allow Courier-IMAP to
authenticate using a MySQL database table.  Install this package if you need
the ability to use a MySQL database table for authentication.


%prep
%setup -q

%configure --localstatedir=%{_localstatedir} \
	--with-authdaemonvar=%{authdaemondir} \
	%{?xflags: %{xflags}}

%build
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

%make
make check

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_sysconfdir}/pam.d
make install-strip DESTDIR=%{buildroot}

#
# Red Hat init.d file
#

mkdir -p %{buildroot}%{_initrddir}
cp courier-imap.sysvinit %{buildroot}%{_initrddir}/courier-imap

#
# Fix imapd.dist
#

sed 's/^IMAPDSTART=.*/IMAPDSTART=YES/' \
	<%{buildroot}%{_sysconfdir}/imapd.dist \
	>%{buildroot}%{_sysconfdir}/imapd.dist.tmp

mv %{buildroot}%{_sysconfdir}/imapd.dist.tmp \
	%{buildroot}%{_sysconfdir}/imapd.dist

sed 's/^IMAPDSSLSTART=.*/IMAPDSSLSTART=YES/' \
	<%{buildroot}%{_sysconfdir}/imapd-ssl.dist \
	>%{buildroot}%{_sysconfdir}/imapd-ssl.dist.tmp

mv %{buildroot}%{_sysconfdir}/imapd-ssl.dist.tmp \
	%{buildroot}%{_sysconfdir}/imapd-ssl.dist

chmod 600 %{buildroot}%{_sysconfdir}/imapd.dist
chmod 600 %{buildroot}%{_sysconfdir}/imapd-ssl.dist

sed 's/^POP3DSTART=.*/POP3DSTART=YES/' \
	<%{buildroot}%{_sysconfdir}/pop3d.dist \
	>%{buildroot}%{_sysconfdir}/pop3d.dist.tmp

mv %{buildroot}%{_sysconfdir}/pop3d.dist.tmp \
	%{buildroot}%{_sysconfdir}/pop3d.dist

sed 's/^POP3DSSLSTART=.*/POP3DSSLSTART=YES/' \
	<%{buildroot}%{_sysconfdir}/pop3d-ssl.dist \
	>%{buildroot}%{_sysconfdir}/pop3d-ssl.dist.tmp

mv %{buildroot}%{_sysconfdir}/pop3d-ssl.dist.tmp \
	%{buildroot}%{_sysconfdir}/pop3d-ssl.dist

chmod 600 %{buildroot}%{_sysconfdir}/pop3d.dist
chmod 600 %{buildroot}%{_sysconfdir}/pop3d-ssl.dist

#
# Red Hat %{_sysconfdir}/profile.d scripts
#

mkdir -p %{buildroot}%{_sysconfdir}/profile.d
cat >%{buildroot}%{_sysconfdir}/profile.d/courier-imap.sh <<EOF
if echo "\$MANPATH" | tr ':' '\012' | fgrep -qx %{_mandir}
then
	:
else
	MANPATH="%{_mandir}:\$MANPATH"
	export MANPATH
	PATH="%{_bindir}:\$PATH"
	if test -w %{_sysconfdir}
	then
		PATH="%{_sbindir}:\$PATH"
	fi
	export PATH
fi
EOF

cat >%{buildroot}%{_sysconfdir}/profile.d/courier-imap.csh <<EOF

if ( \$?MANPATH ) then
	true
else
	setenv MANPATH ""
endif

echo "\$MANPATH" | tr ':' '\012' | fgrep -qx %{_mandir}

if ( \$? ) then
	true
else
	setenv MANPATH "%{_mandir}:\$MANPATH"
	setenv PATH "%{_bindir}:\$PATH"
	test -w %{_sysconfdir}
	if ( \$? ) then
		true
	else
		setenv PATH "%{_sbindir}:\$PATH"
	endif
endif
EOF

cp imap/README README.imap
cp maildir/README.maildirquota.txt README.maildirquota
cp maildir/README.sharedfolders.txt README.sharedfolders

####
## Create config files for sysconftool-rpmupgrade (see below)

mkdir -p %{buildroot}%{_datadir}/courier-imap
cp sysconftool %{buildroot}%{_datadir}/courier-imap/sysconftool
chmod 555 %{buildroot}%{_datadir}/courier-imap/sysconftool
cat >%{buildroot}%{_datadir}/courier-imap/configlist <<EOF
%{_sysconfdir}/imapd.dist
%{_sysconfdir}/imapd-ssl.dist
%{_sysconfdir}/pop3d.dist
%{_sysconfdir}/pop3d-ssl.dist
EOF

cp /dev/null %{buildroot}%{_datadir}/courier-imap/configlist.ldap
cp /dev/null %{buildroot}%{_datadir}/courier-imap/configlist.mysql

chmod 644 %{buildroot}%{_datadir}/courier-imap/configlist*

######
##
## Ok, upgrades are going to get ugly.  Because we install $filename.dist
## instead of $filename, and the old package has $filename listed as a config,
## RPM will back up $filename to $filename.rpmsave.  This will happen AFTER
## we will run the post scripts, effectively blowing away our configurations.
## PUT THEM BACK BY RUNNING THE FOLLOWING SCRIPT FROM A TRIGGER.

cat >%{buildroot}%{_datadir}/courier-imap/sysconftool-rpmupgrade <<EOF
#!/bin/sh

for f in \$* "."
do
	if test \$f = "."
	then
		continue
	fi

	base=\`echo \$f | sed 's/\\.dist\$//'\`
	if test -f \$base.dist -a ! -f \$base
	then
		cp -pr \$base.dist \$base
	fi
done
EOF

chmod 555 %{buildroot}%{_datadir}/courier-imap/sysconftool-rpmupgrade

#
#  Check if authdaemond was installed, make sure to include authdaemon
#  directory
#

cp /dev/null authdaemon.files

. authlib/authdaemonrc

if test "$authdaemonvar" != ""
then
	echo "%{_sysconfdir}/authdaemonrc.dist" >>%{buildroot}%{_datadir}/courier-imap/configlist
	echo "%{_sysconfdir}/authdaemonrc.dist" >>authdaemon.files
	echo '%dir %attr(700, root, root) ' $authdaemonvar >>authdaemon.files
	touch %{buildroot}/$authdaemonvar/lock || exit 1
	touch %{buildroot}/$authdaemonvar/pid || exit 1
	authlib/authmksock %{buildroot}/$authdaemonvar/socket || exit 1
	chmod 777 %{buildroot}/$authdaemonvar/socket || exit 1
	echo '%ghost %attr(600, root, root) ' $authdaemonvar/lock >>authdaemon.files
	echo '%ghost %attr(644, root, root) ' $authdaemonvar/pid >>authdaemon.files
	echo '%ghost %attr(-, root, root) ' $authdaemonvar/socket >>authdaemon.files
fi

(cd %{buildroot} ; find .%{_libexecdir} -type f ! -name authdaemond.ldap ! -name authdaemond.mysql -print ) | cut -c2- >>authdaemon.files

cp /dev/null authdaemon.files.ldap
cp /dev/null authdaemon.files.mysql

test ! -f %{buildroot}%{_libexecdir}/authlib/authdaemond.mysql ||
	echo %{_libexecdir}/authlib/authdaemond.mysql >>authdaemon.files.mysql

test ! -f %{buildroot}%{_libexecdir}/authlib/authdaemond.ldap || \
	echo %{_libexecdir}/authlib/authdaemond.ldap >>authdaemon.files.ldap

if test -f %{buildroot}%{_libexecdir}/authlib/authdaemond.mysql
then
	echo %{_sysconfdir}/authmysqlrc.dist >>%{buildroot}%{_datadir}/courier-imap/configlist.mysql
	echo %{_sysconfdir}/authmysqlrc.dist >>authdaemon.files.mysql
fi

if test -f %{buildroot}%{_libexecdir}/authlib/authdaemond.ldap
then
	echo %{_sysconfdir}/authldaprc.dist >>%{buildroot}%{_datadir}/courier-imap/configlist.ldap
	echo %{_sysconfdir}/authldaprc.dist >>authdaemon.files.ldap

	if test -d %{_sysconfdir}/openldap/schema
	then
		mkdir -p %{buildroot}%{_sysconfdir}/openldap/schema
		cp authlib/authldap.schema %{buildroot}%{_sysconfdir}/openldap/schema/courier.schema
		echo '%config(noreplace) %attr(444, root, root) %{_sysconfdir}/openldap/schema/courier.schema' >>authdaemon.files.ldap
	fi
fi

mkdir -p %{buildroot}%{_localstatedir}
touch %{buildroot}%{_localstatedir}/imapd.pid
touch %{buildroot}%{_localstatedir}/imapd-ssl.pid
touch %{buildroot}%{_localstatedir}/imapd.pid.lock
touch %{buildroot}%{_localstatedir}/imapd-ssl.pid.lock
touch %{buildroot}%{_localstatedir}/pop3d.pid
touch %{buildroot}%{_localstatedir}/pop3d-ssl.pid
touch %{buildroot}%{_localstatedir}/pop3d.pid.lock
touch %{buildroot}%{_localstatedir}/pop3d-ssl.pid.lock

# move /usr/share progs to /usr/share/courier-imap and fix symlinks
pushd %{buildroot}
  cd usr/share
  mv {makeuserdb,mkimapdcert,mkpop3dcert,pw2userdb,userdb,vchkpw2userdb} courier-imap
  cd ../sbin
  ln -sf ../..%{_datadir}/courier-imap/{makeuserdb,mkimapdcert,mkpop3dcert,pw2userdb,userdb,vchkpw2userdb} .
popd

%post
/sbin/chkconfig --del courier-imap
/sbin/chkconfig --add courier-imap
%{_datadir}/courier-imap/sysconftool `cat %{_datadir}/courier-imap/configlist` >/dev/null


%post ldap
%{_datadir}/courier-imap/sysconftool `cat %{_datadir}/courier-imap/configlist.ldap` >/dev/null


%post mysql
%{_datadir}/courier-imap/sysconftool `cat %{_datadir}/courier-imap/configlist.mysql` >/dev/null


%preun ldap
%{_libexecdir}/imapd.rc stop
%{_libexecdir}/imapd-ssl.rc stop
%{_libexecdir}/pop3d.rc stop
%{_libexecdir}/pop3d-ssl.rc stop


%preun mysql
%{_libexecdir}/imapd.rc stop
%{_libexecdir}/imapd-ssl.rc stop
%{_libexecdir}/pop3d.rc stop
%{_libexecdir}/pop3d-ssl.rc stop


%preun
if test "$1" = "0"
then
	/sbin/chkconfig --del courier-imap
fi

%{_libexecdir}/imapd.rc stop
%{_libexecdir}/imapd-ssl.rc stop
%{_libexecdir}/pop3d.rc stop
%{_libexecdir}/pop3d-ssl.rc stop


%triggerpostun -- courier-imap
test ! -f %{_datadir}/courier-imap/configlist || %{_datadir}/courier-imap/sysconftool-rpmupgrade `cat %{_datadir}/courier-imap/configlist` >/dev/null


%triggerpostun ldap -- courier-imap-ldap
test ! -f %{_datadir}/courier-imap/configlist.ldap || %{_datadir}/courier-imap/sysconftool-rpmupgrade `cat %{_datadir}/courier-imap/configlist.ldap` >/dev/null


%triggerpostun mysql -- courier-imap-mysql
test ! -f %{_datadir}/courier-imap/configlist.mysql || %{_datadir}/courier-imap/sysconftool-rpmupgrade `cat %{_datadir}/courier-imap/configlist.mysql` >/dev/null


%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
rm -rf $RPM_BUILD_DIR/%{name}-%{version}


%files -f authdaemon.files
%defattr(-, root, root)
%doc AUTHORS COPYING imap/BUGS README README.imap README.maildirquota
%doc imap/FAQ imap/FAQ.html README.sharedfolders authlib/README.*
%config %{_sysconfdir}/pam.d/imap
%config %{_sysconfdir}/pam.d/pop3
%config %{_sysconfdir}/imapd-ssl.dist
%config %{_sysconfdir}/imapd.cnf
%config %{_sysconfdir}/imapd.dist
%config %{_sysconfdir}/pop3d-ssl.dist
%config %{_sysconfdir}/pop3d.cnf
%config %{_sysconfdir}/pop3d.dist
%config %{_sysconfdir}/quotawarnmsg.example
%attr(755, root, root) %config %{_sysconfdir}/profile.d/courier-imap.csh
%attr(755, root, root) %config %{_sysconfdir}/profile.d/courier-imap.sh
%attr(755, root, root) %{_initrddir}/courier-imap
%dir %{_libexecdir}/authlib
%{_bindir}/couriertls
%{_bindir}/imapd
%{_bindir}/maildirmake
%{_bindir}/pop3d
%{_sbindir}/imaplogin
%{_sbindir}/makeuserdb
%{_sbindir}/mkimapdcert
%{_sbindir}/mkpop3dcert
%{_sbindir}/pop3login
%{_sbindir}/pw2userdb
%{_sbindir}/userdb
%{_sbindir}/userdbpw
%{_sbindir}/vchkpw2userdb
%{_mandir}/man1/maildirmake.1*
%{_mandir}/man8/authcram.8*
%{_mandir}/man8/authdaemon.8*
%{_mandir}/man8/authdaemond.8*
%{_mandir}/man8/authldap.8*
%{_mandir}/man8/authlib.8*
%{_mandir}/man8/authmysql.8*
%{_mandir}/man8/authpam.8*
%{_mandir}/man8/authpwd.8*
%{_mandir}/man8/authshadow.8*
%{_mandir}/man8/authuserdb.8*
%{_mandir}/man8/authvchkpw.8*
%{_mandir}/man8/couriertcpd.8*
%{_mandir}/man8/deliverquota.8*
%{_mandir}/man8/imapd.8*
%{_mandir}/man8/makeuserdb.8*
%{_mandir}/man8/mkimapdcert.8*
%{_mandir}/man8/mkpop3dcert.8*
%{_mandir}/man8/pw2userdb.8*
%{_mandir}/man8/userdb.8*
%{_mandir}/man8/userdbpw.8*
%{_mandir}/man8/vchkpw2userdb.8*
%{_datadir}/courier-imap/makeuserdb
%{_datadir}/courier-imap/mkimapdcert
%{_datadir}/courier-imap/mkpop3dcert
%{_datadir}/courier-imap/pw2userdb
%{_datadir}/courier-imap/sysconftool
%{_datadir}/courier-imap/sysconftool-rpmupgrade
%{_datadir}/courier-imap/userdb
%{_datadir}/courier-imap/vchkpw2userdb
%{_datadir}/courier-imap/configlist


%ghost %attr(600, root, root) %{_localstatedir}/imapd.pid
%ghost %attr(600, root, root) %{_localstatedir}/imapd-ssl.pid
%ghost %attr(600, root, root) %{_localstatedir}/imapd.pid.lock
%ghost %attr(600, root, root) %{_localstatedir}/imapd-ssl.pid.lock

%ghost %attr(600, root, root) %{_localstatedir}/pop3d.pid
%ghost %attr(600, root, root) %{_localstatedir}/pop3d-ssl.pid
%ghost %attr(600, root, root) %{_localstatedir}/pop3d.pid.lock
%ghost %attr(600, root, root) %{_localstatedir}/pop3d-ssl.pid.lock

%files ldap -f authdaemon.files.ldap
%defattr(-, root, root)
%{_datadir}/courier-imap/configlist.ldap

%files mysql -f authdaemon.files.mysql
%defattr(-, root, root)
%{_datadir}/courier-imap/configlist.mysql

%changelog
* Tue Apr 16 2002 Vincent Danen <vdanen@mandrakesoft.com> 1.3.11-2rph
- rebuild with rph extension

* Fri Sep 21 2001 Vincent Danen <vdanen@mandrakesoft.com> 1.3.11-1mdk
- 1.3.11
- move /usr/share/* (execs and configlists) to /usr/share/courier-imap

* Sun Jan 28 2001 Vincent Danen <vdanen@mandrakesoft.com> 1.3.2-1mdk
- first Mandrake build